/* 

    CardBoardFish HTTPSMS JavaScript Library v1.0

    Copyright 2007 CardBoardFish 
    http://www.cardboardfish.com/

*/

/* Common functions */

if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (elt /*, from*/) {
        var len = this.length;

        var from = Number(arguments[1]) || 0;
        from = (from < 0) ? Math.ceil(from) : Math.floor(from);
        if (from < 0) {
            from += len;
        }
    
        for (; from < len; from++) {
            if (from in this && this[from] === elt) {
                return from;
            }
        }
        return -1;
    };
}

if (!String.prototype.split) {
    String.prototype.split = function (on) {
        var len = this.length;
        var i;

        var to_return = [];

        var top = 0;
        var part;
        for (i = 0; i < len; i++) {
            part = this.substring(i, i + on.length);
            if (part === on) {
                to_return.push(this.substring(top, i));
                top = i;
            }
        }
        return to_return;
    };
}

function easyXHR() {
    var req;
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        try {
            req = new window.ActiveXObject("Msxml2.XMLHTTP.6.0");
        } catch (e) {
            try {
                req = new window.ActiveXObject("Msxml2.XMLHTTP.3.0");
            } catch (e2) {
                try {
                    req = new window.ActiveXObject("Msxml2.XMLHTTP");
                } catch (e3) {
                    try {
                        req = new window.ActiveXObject("Microsoft.XMLHTTP");
                    } catch (e4) {
                        alert("No ActiveX XHR useable. Aborting.");
                        return;
                    }
                }
            }
        }
    } else {
        alert("Failed to create XHR object. Aborting AJAX code.");
    }
    return req;
}

/* End of common functions */

var cbfusername;
var cbfpassword;
var cbfclientType = "D";
var cbfError;

var CBF_SCODE_SENT = "CBF_SCODE_SENT";
var CBF_SCODE_OK = "CBF_SCODE_OK";
var CBF_SCODE_NOT_OK = "CBF_SCODE_NOT_OK";
var CBF_SEND_OK = "CBF_SEND_OK";
var CBF_SEND_ERRORS = "CBF_SEND_ERRORS";
var CBF_BALANCE = "CBF_BALANCE";

var cbfhttpsmsurl = "http://sms1.cardboardfish.com:9001/";

function setCbfStatus(state) {
    var cs = document.getElementById("cbfstatus");
    if (cs) {
        cs.innerHTML = state;
    }
}

function cbfInit(un, p, t) {
    if (un && p) {
        cbfusername = un;
        cbfpassword = p;
        if (t) {
            cbfclientType = t;
        }
    }
}

function cbfIncludeIf(name, value) {
    if (value) {
        return "&" + name + "=" + value;
    } else {
        return "";
    }
}

function cbfdebug(message) {
    if (window.debug) {
        debug("CBFSMS: " + message);
    }
}

function cbfBalance() {
    var req = easyXHR();
    var url = "http://winsmsserver.cardboardfish.com/";
    var requeststring = "cgi-bin/osxwidget/balance.cgi?UN=" + cbfusername + "&P=" + cbfpassword;
    req.open("GET", url + requeststring, true);
    req.onreadystatechange = function() {
        if (req.readyState == 4) {
            if (req.responseText.substring(0,3) == 'ERR') {
                setCbfStatus(CBF_BALANCE + " - -");
            } else {
                setCbfStatus(CBF_BALANCE + " " + req.responseText);
            }
        }
    };
    req.send(null);
}

function cbfSCode(sa, scode) {
    var req = easyXHR();
    var url = "http://winsmsserver.cardboardfish.com/";
    var requeststring;
    if (scode) {
        requeststring = "cgi-bin/osxwidget/pin.cgi?UN=" + cbfusername + "&P=" + cbfpassword + "&SA=" + sa + "&SC=" + scode + "&action=CheckSCode";
        req.open("GET", url + requeststring, true);
        req.onreadystatechange = function() {
            if (req.readyState == 4) {
                if (req.responseText == "OK") {
                    setCbfStatus(CBF_SCODE_OK);
                } else {
                    setCbfStatus(CBF_SCODE_NOT_OK);
                }
            }
        };
        req.send(null);
    } else {
        requeststring = "cgi-bin/osxwidget/pin.cgi?UN=" + cbfusername + "&P=" + cbfpassword + "&SA=" + sa;
        cbfdebug("Request: " + requeststring);
        req.open("GET", url + requeststring, true);
        req.onreadystatechange = function() {
            if (req.readyState == 4) {
                if (req.responseText.substring(0,3) == 'ERR') {
                    setCbfStatus(CBF_SCODE_NOT_OK);
                } else {
                    setCbfStatus(CBF_SCODE_SENT);
                }
            }
        };
        req.send(null);
    }
    return false;
}

function validDestinations(dests, cc) {
    if (!dests) {
	    return false;
	}
	var ds = dests.split(",");
	var i;
	var dest;
	var dre = /(\+|00)?(\d{8,16})/
	var parts;
    var returnparts = [];
	for (i = 0; i < ds.length; i++) {
	    dest = ds[i];
		parts = dre.exec(dest);
		if (!dest || !parts) {
		    cbfError = "At least one recipient is invalid."
			return false;
		} else {
            if (parts[2].charAt(0) == "0") {
                returnparts.push(cc + parts[2].substring(1));
            } else {
                returnparts.push(parts[2]);
            }
        }
	}
    if (returnparts.length > 10) {
        cbfError = "Too many recipients specified. Maximum 10.";
        return false;
    }
	return returnparts;
}

function my_url_encode(str) {
    var i;
    var encoded = "";
    var chr;
    for (i = 0; i < str.length; i++) {
        encoded += "%"
        chr = str.charCodeAt(i);
        if (chr == 0x20AC) {
            encoded += "80";
        } else {
            encoded += chr.toString(16)
        }
    }
    return encoded;
}

function sendreply() {
}

function cbfSendSMS(cc, destination, source, message, st, scode, dc, dr, ud, vp, du, lt) {
    var ds = validDestinations(destination, cc);
    if (!ds) {
	    return null;
	}
	// TODO: Validate

    /* Build request */
    cbfdebug("Building requeststring");
    if (st === null || st == "1") {
        sat = "&ST=1";
    } else if (st == "0") {
        sat = "&ST=0";
    } else if (st == "5") {
        sat = "&ST=5";
    } else {
        cbfError = "Invalid source address type.";
        return null;
    }
    var requestString = "HTTPSMS?S=" + cbfclientType + "&UN=" + cbfusername + "&P=" + cbfpassword + "&DA=" + ds.join(",") + "&SA=" + my_url_encode(source) + "&M=" + my_url_encode(message) + cbfIncludeIf("SCODE", scode) + sat + cbfIncludeIf("DC", dc) + cbfIncludeIf("DR", dr) + cbfIncludeIf("UD", ud) + cbfIncludeIf("VP", vp) + cbfIncludeIf("DU" + du) + cbfIncludeIf("LT", lt);
    alert("Request: " + requestString);
    var req = easyXHR();
    req.open("GET", cbfhttpsmsurl + requestString, false);
    req.onreadystatechange = function() {
        if (req.readyState == 4) {
            var responsestring = req.responseText;
            alert("Response: " + responsestring);
            var responses = responsestring.replace(/[\n\r]/g,'').split(" ");
        
            if (responses[0] !== "OK") {
                if (req.status == "401") {
                    cbfError = "Invalid username / password.";
                } else if (req.status == "500") {
                    cbfError = "Server is down, please try again later.";
                } else if (req.status == "402") {
                    cbfError = "There is not enough credit in your account.";
                } else if (req.status == "503") {
                    cbfError = "Invalid recipient.";
                } else if (req.status == "400") {
                    cbfError = "Error. Please update, or contact CardBoardFish.";
                }
                setCbfStatus(CBF_SEND_ERRORS);
            } else {
                responses.shift();
                setCbfStatus(CBF_SEND_OK + " " + responses.join(" "));
            }
        }
    };
    req.send(null);
    return true;
}

function processIncoming(incoming) {
    var to_return = [];
    var parts1 = incoming.split("#");
    var parts2;
    
    var i;    
    for (i = 0; i < parts1.length; i++) {
        parts2 = parts1[i].split(":");
        to_return.push(parts2);
    }
    return to_return;
}

function pollServer() {
    var incoming;
    var incomingstring;
    var req = easyXHR();
    if (req) {
        req.open("GET", cbfhttpsmsurl + "ClientDR/ClientDR?UN=" + cbfusername + "&P=" + cbfpassword, false);
        req.send(null);
        incomingstring = req.responseText;
        if (incomingstring !== "0#") {
            incoming = processIncoming(incomingstring);
        }
    }
    return incoming;    
}